/* vfs.c generated by valac 0.10.4, the Vala compiler
 * generated from vfs.vala, do not modify */

/*
 * Desktop Agnostic Library: VFS implementation interface.
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <libdesktop-agnostic/desktop-agnostic.h>


#define DESKTOP_AGNOSTIC_VFS_TYPE_IMPLEMENTATION (desktop_agnostic_vfs_implementation_get_type ())
#define DESKTOP_AGNOSTIC_VFS_IMPLEMENTATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_IMPLEMENTATION, DesktopAgnosticVFSImplementation))
#define DESKTOP_AGNOSTIC_VFS_IS_IMPLEMENTATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_IMPLEMENTATION))
#define DESKTOP_AGNOSTIC_VFS_IMPLEMENTATION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_IMPLEMENTATION, DesktopAgnosticVFSImplementationIface))

typedef struct _DesktopAgnosticVFSImplementation DesktopAgnosticVFSImplementation;
typedef struct _DesktopAgnosticVFSImplementationIface DesktopAgnosticVFSImplementationIface;

#define DESKTOP_AGNOSTIC_VFS_TYPE_FILE (desktop_agnostic_vfs_file_get_type ())
#define DESKTOP_AGNOSTIC_VFS_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_FILE, DesktopAgnosticVFSFile))
#define DESKTOP_AGNOSTIC_VFS_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_AGNOSTIC_VFS_TYPE_FILE, DesktopAgnosticVFSFileClass))
#define DESKTOP_AGNOSTIC_VFS_IS_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_FILE))
#define DESKTOP_AGNOSTIC_VFS_IS_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_AGNOSTIC_VFS_TYPE_FILE))
#define DESKTOP_AGNOSTIC_VFS_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_FILE, DesktopAgnosticVFSFileClass))

typedef struct _DesktopAgnosticVFSFile DesktopAgnosticVFSFile;
typedef struct _DesktopAgnosticVFSFileClass DesktopAgnosticVFSFileClass;

#define DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_MONITOR (desktop_agnostic_vfs_volume_monitor_get_type ())
#define DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_MONITOR, DesktopAgnosticVFSVolumeMonitor))
#define DESKTOP_AGNOSTIC_VFS_IS_VOLUME_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_MONITOR))
#define DESKTOP_AGNOSTIC_VFS_VOLUME_MONITOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME_MONITOR, DesktopAgnosticVFSVolumeMonitorIface))

typedef struct _DesktopAgnosticVFSVolumeMonitor DesktopAgnosticVFSVolumeMonitor;
typedef struct _DesktopAgnosticVFSVolumeMonitorIface DesktopAgnosticVFSVolumeMonitorIface;

#define DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME (desktop_agnostic_vfs_volume_get_type ())
#define DESKTOP_AGNOSTIC_VFS_VOLUME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME, DesktopAgnosticVFSVolume))
#define DESKTOP_AGNOSTIC_VFS_IS_VOLUME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME))
#define DESKTOP_AGNOSTIC_VFS_VOLUME_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_VOLUME, DesktopAgnosticVFSVolumeIface))

typedef struct _DesktopAgnosticVFSVolume DesktopAgnosticVFSVolume;
typedef struct _DesktopAgnosticVFSVolumeIface DesktopAgnosticVFSVolumeIface;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

typedef void (*DesktopAgnosticVFSVolumeCallback) (void* user_data);
typedef enum  {
	DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR_MOUNT,
	DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR_UNMOUNT,
	DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR_EJECT
} DesktopAgnosticVFSVolumeError;
#define DESKTOP_AGNOSTIC_VFS_VOLUME_ERROR desktop_agnostic_vfs_volume_error_quark ()
struct _DesktopAgnosticVFSVolumeIface {
	GTypeInterface parent_iface;
	gboolean (*is_mounted) (DesktopAgnosticVFSVolume* self);
	void (*mount) (DesktopAgnosticVFSVolume* self, DesktopAgnosticVFSVolumeCallback callback, void* callback_target);
	gboolean (*mount_finish) (DesktopAgnosticVFSVolume* self, GError** error);
	void (*unmount) (DesktopAgnosticVFSVolume* self, DesktopAgnosticVFSVolumeCallback callback, void* callback_target);
	gboolean (*unmount_finish) (DesktopAgnosticVFSVolume* self, GError** error);
	gboolean (*can_eject) (DesktopAgnosticVFSVolume* self);
	void (*eject) (DesktopAgnosticVFSVolume* self, DesktopAgnosticVFSVolumeCallback callback, void* callback_target);
	gboolean (*eject_finish) (DesktopAgnosticVFSVolume* self, GError** error);
	const char* (*get_name) (DesktopAgnosticVFSVolume* self);
	DesktopAgnosticVFSFile* (*get_uri) (DesktopAgnosticVFSVolume* self);
	char* (*get_icon) (DesktopAgnosticVFSVolume* self);
};

struct _DesktopAgnosticVFSVolumeMonitorIface {
	GTypeInterface parent_iface;
	void* (*get_implementation) (DesktopAgnosticVFSVolumeMonitor* self);
	GList* (*get_volumes) (DesktopAgnosticVFSVolumeMonitor* self);
};

struct _DesktopAgnosticVFSImplementationIface {
	GTypeInterface parent_iface;
	void (*init) (DesktopAgnosticVFSImplementation* self);
	GSList* (*files_from_uri_list) (DesktopAgnosticVFSImplementation* self, const char* uri_list, GError** error);
	DesktopAgnosticVFSVolumeMonitor* (*volume_monitor_get_default) (DesktopAgnosticVFSImplementation* self);
	void (*shutdown) (DesktopAgnosticVFSImplementation* self);
	const char* (*get_name) (DesktopAgnosticVFSImplementation* self);
	GType (*get_file_type) (DesktopAgnosticVFSImplementation* self);
	GType (*get_file_monitor_type) (DesktopAgnosticVFSImplementation* self);
	GType (*get_trash_type) (DesktopAgnosticVFSImplementation* self);
	GType (*get_volume_type) (DesktopAgnosticVFSImplementation* self);
};


extern DesktopAgnosticVFSImplementation* desktop_agnostic_vfs_vfs;
DesktopAgnosticVFSImplementation* desktop_agnostic_vfs_vfs = NULL;

GType desktop_agnostic_vfs_file_get_type (void) G_GNUC_CONST;
GQuark desktop_agnostic_vfs_volume_error_quark (void);
GType desktop_agnostic_vfs_volume_get_type (void) G_GNUC_CONST;
GType desktop_agnostic_vfs_volume_monitor_get_type (void) G_GNUC_CONST;
GType desktop_agnostic_vfs_implementation_get_type (void) G_GNUC_CONST;
void desktop_agnostic_vfs_implementation_init (DesktopAgnosticVFSImplementation* self);
GSList* desktop_agnostic_vfs_implementation_files_from_uri_list (DesktopAgnosticVFSImplementation* self, const char* uri_list, GError** error);
DesktopAgnosticVFSVolumeMonitor* desktop_agnostic_vfs_implementation_volume_monitor_get_default (DesktopAgnosticVFSImplementation* self);
void desktop_agnostic_vfs_implementation_shutdown (DesktopAgnosticVFSImplementation* self);
const char* desktop_agnostic_vfs_implementation_get_name (DesktopAgnosticVFSImplementation* self);
GType desktop_agnostic_vfs_implementation_get_file_type (DesktopAgnosticVFSImplementation* self);
GType desktop_agnostic_vfs_implementation_get_file_monitor_type (DesktopAgnosticVFSImplementation* self);
GType desktop_agnostic_vfs_implementation_get_trash_type (DesktopAgnosticVFSImplementation* self);
GType desktop_agnostic_vfs_implementation_get_volume_type (DesktopAgnosticVFSImplementation* self);
DesktopAgnosticVFSImplementation* desktop_agnostic_vfs_get_default (GError** error);
void desktop_agnostic_vfs_init (GError** error);
void desktop_agnostic_vfs_shutdown (GError** error);
GSList* desktop_agnostic_vfs_files_from_uri_list (const char* uri_list, GError** error);



void desktop_agnostic_vfs_implementation_init (DesktopAgnosticVFSImplementation* self) {
	DESKTOP_AGNOSTIC_VFS_IMPLEMENTATION_GET_INTERFACE (self)->init (self);
}


GSList* desktop_agnostic_vfs_implementation_files_from_uri_list (DesktopAgnosticVFSImplementation* self, const char* uri_list, GError** error) {
	return DESKTOP_AGNOSTIC_VFS_IMPLEMENTATION_GET_INTERFACE (self)->files_from_uri_list (self, uri_list, error);
}


DesktopAgnosticVFSVolumeMonitor* desktop_agnostic_vfs_implementation_volume_monitor_get_default (DesktopAgnosticVFSImplementation* self) {
	return DESKTOP_AGNOSTIC_VFS_IMPLEMENTATION_GET_INTERFACE (self)->volume_monitor_get_default (self);
}


void desktop_agnostic_vfs_implementation_shutdown (DesktopAgnosticVFSImplementation* self) {
	DESKTOP_AGNOSTIC_VFS_IMPLEMENTATION_GET_INTERFACE (self)->shutdown (self);
}


const char* desktop_agnostic_vfs_implementation_get_name (DesktopAgnosticVFSImplementation* self) {
	return DESKTOP_AGNOSTIC_VFS_IMPLEMENTATION_GET_INTERFACE (self)->get_name (self);
}


GType desktop_agnostic_vfs_implementation_get_file_type (DesktopAgnosticVFSImplementation* self) {
	return DESKTOP_AGNOSTIC_VFS_IMPLEMENTATION_GET_INTERFACE (self)->get_file_type (self);
}


GType desktop_agnostic_vfs_implementation_get_file_monitor_type (DesktopAgnosticVFSImplementation* self) {
	return DESKTOP_AGNOSTIC_VFS_IMPLEMENTATION_GET_INTERFACE (self)->get_file_monitor_type (self);
}


GType desktop_agnostic_vfs_implementation_get_trash_type (DesktopAgnosticVFSImplementation* self) {
	return DESKTOP_AGNOSTIC_VFS_IMPLEMENTATION_GET_INTERFACE (self)->get_trash_type (self);
}


GType desktop_agnostic_vfs_implementation_get_volume_type (DesktopAgnosticVFSImplementation* self) {
	return DESKTOP_AGNOSTIC_VFS_IMPLEMENTATION_GET_INTERFACE (self)->get_volume_type (self);
}


static void desktop_agnostic_vfs_implementation_base_init (DesktopAgnosticVFSImplementationIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		/**
		     * The (unique) name of the implementation.
		     */
		g_object_interface_install_property (iface, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
		g_object_interface_install_property (iface, g_param_spec_gtype ("file-type", "file-type", "file-type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
		g_object_interface_install_property (iface, g_param_spec_gtype ("file-monitor-type", "file-monitor-type", "file-monitor-type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
		g_object_interface_install_property (iface, g_param_spec_gtype ("trash-type", "trash-type", "trash-type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
		g_object_interface_install_property (iface, g_param_spec_gtype ("volume-type", "volume-type", "volume-type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	}
}


GType desktop_agnostic_vfs_implementation_get_type (void) {
	static volatile gsize desktop_agnostic_vfs_implementation_type_id__volatile = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_implementation_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSImplementationIface), (GBaseInitFunc) desktop_agnostic_vfs_implementation_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType desktop_agnostic_vfs_implementation_type_id;
		desktop_agnostic_vfs_implementation_type_id = g_type_register_static (G_TYPE_INTERFACE, "DesktopAgnosticVFSImplementation", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (desktop_agnostic_vfs_implementation_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&desktop_agnostic_vfs_implementation_type_id__volatile, desktop_agnostic_vfs_implementation_type_id);
	}
	return desktop_agnostic_vfs_implementation_type_id__volatile;
}


DesktopAgnosticVFSImplementation* desktop_agnostic_vfs_get_default (GError** error) {
	DesktopAgnosticVFSImplementation* result = NULL;
	GError * _inner_error_ = NULL;
	if (desktop_agnostic_vfs_vfs == NULL) {
		GType type;
		type = desktop_agnostic_get_module_type ("vfs", "vfs", &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		}
		if (type == G_TYPE_INVALID) {
			result = NULL;
			return result;
		} else {
			GObject* _tmp0_;
			DesktopAgnosticVFSImplementation* _tmp1_;
			desktop_agnostic_vfs_vfs = (_tmp1_ = DESKTOP_AGNOSTIC_VFS_IMPLEMENTATION ((_tmp0_ = g_object_new (type, NULL), G_IS_INITIALLY_UNOWNED (_tmp0_) ? g_object_ref_sink (_tmp0_) : _tmp0_)), _g_object_unref0 (desktop_agnostic_vfs_vfs), _tmp1_);
		}
	}
	result = desktop_agnostic_vfs_vfs;
	return result;
}


/**
   * Initializes the VFS, if the backend needs it.
   */
void desktop_agnostic_vfs_init (GError** error) {
	DesktopAgnosticVFSImplementation* vfs;
	GError * _inner_error_ = NULL;
	vfs = desktop_agnostic_vfs_get_default (&_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	if (vfs != NULL) {
		desktop_agnostic_vfs_implementation_init (vfs);
	}
}


/**
   * Shuts down the VFS, if the backend needs it.
   */
void desktop_agnostic_vfs_shutdown (GError** error) {
	DesktopAgnosticVFSImplementation* vfs;
	GError * _inner_error_ = NULL;
	vfs = desktop_agnostic_vfs_get_default (&_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	if (vfs != NULL) {
		desktop_agnostic_vfs_implementation_shutdown (vfs);
	}
}


/**
   * Creates a list of files based on a newline-delimited list of URIs.
   */
GSList* desktop_agnostic_vfs_files_from_uri_list (const char* uri_list, GError** error) {
	GSList* result = NULL;
	DesktopAgnosticVFSImplementation* vfs;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (uri_list != NULL, NULL);
	vfs = desktop_agnostic_vfs_get_default (&_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	if (vfs == NULL) {
		result = NULL;
		return result;
	} else {
		GSList* _tmp0_;
		_tmp0_ = desktop_agnostic_vfs_implementation_files_from_uri_list (vfs, uri_list, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		}
		result = _tmp0_;
		return result;
	}
}




